//+------------------------------------------------------------------+
//|                                                        Speed.mq4 |
//|                      Copyright  2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_maximum 3.0
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 Green
#property indicator_color3 Yellow

extern int period   = 20;
extern double level = 50.0;
double uno[];
double due[];
double tre[];
double ATR[];
double StdDev[];
double RSIOnArray1[];
double RSIOnArray2[];

int init() {
   IndicatorBuffers(7);
   SetIndexBuffer(0, uno);
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 1);
   SetIndexBuffer(1, due);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 1);
   SetIndexBuffer(2, tre);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID, 1);
   SetIndexDrawBegin(0, period);
   SetIndexDrawBegin(1, period);
   SetIndexBuffer(3, ATR);
   SetIndexBuffer(4, StdDev);
   SetIndexBuffer(5, RSIOnArray1);
   SetIndexBuffer(6, RSIOnArray2);
   IndicatorShortName(" Speed " + period);
   SetIndexLabel(0, "Trend");
   SetIndexLabel(1, "Correction");
   SetIndexLabel(2, "Sleep");
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int i  = IndicatorCounted();
   if ( i < 0) return (-1);
   if ( i > 0) i--;
   int j = Bars - i ;
   for (int h = j - 1; h >= 0; h--) {
      ATR[h] = iATR(Symbol(),0, period,h);
      StdDev[h] = iStdDev(Symbol(),0,period,0,MODE_SMA, PRICE_MEDIAN,h);
   }
   for (int k = j - 1; k >= 0; k--) {
      RSIOnArray1[k] = iRSIOnArray(StdDev,0,period,k);
      RSIOnArray2[k] = iRSIOnArray(ATR,0,period,k);
      if (RSIOnArray1[k] >= level && RSIOnArray2[k] >= level) {
         uno[k] = 3;
         due[k] = 0;
         tre[k] = 0;
      } else {
         if (RSIOnArray1[k] < level && RSIOnArray2[k] < level) {
            uno[k] = 0;
            due[k] = 0;
            tre[k] = 1;
         } else {
            uno[k] = 0;
            due[k] = 2;
            tre[k] = 0;
         }
      }
   }
   return (0);
}